/*
 * WebApiSegura Token JWT XrmAPI
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.api;

import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;
import io.swagger.client.BuildParameters;
import io.swagger.client.WebserviceParameters;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.CSolicitarRCAttributes;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class SolicitarrcApi {
    private ApiClient apiClient;
	static final String URLENCODE="application/x-www-form-urlencoded";

	static final String APIMETHOD= "/api/solicitarrc/";
	
	static final String ACCEPTTEXT="Accept";
	static final String AUTH_TEXT="Authorization";
	static final String TEXT_XML="text/xml";
	
	static final String APIMETHODSLASH= "/api/solicitarrc";

	static final String APPJSON="application/json";	
	
	static final String CONTENTTYPE="Content-Type";
	
	static final String TEXTJSON="text/json";
	
	
    public SolicitarrcApi() {
        this(Configuration.getDefaultApiClient());
    }

    public SolicitarrcApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for solicitarrcClearcache
     * @param authorization JWT Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call solicitarrcClearcacheCall(String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody1 = null;

        
        String localVarPath1 = APIMETHOD + "clearcache";

        List<Pair> localVarQueryParams1 = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams1 = new ArrayList<>();

        Map<String, String> localVarHeaderParams1 = new HashMap<>();
        if (authorization != null){
			localVarHeaderParams1.put(AUTH_TEXT, apiClient.parameterToString(authorization));
		}

        Map<String, Object> localVarFormParams1 = new HashMap<>();

        final String[] localVarAccepts1 = {
            APPJSON, TEXTJSON, TEXT_XML
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts1);
        if (localVarAccept != null) localVarHeaderParams1.put(ACCEPTTEXT, localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams1.put(CONTENTTYPE, localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames1 = new String[] {  };
        BuildParameters buildParameters1=new BuildParameters();
			buildParameters1.setPath(localVarPath1);
			buildParameters1.setMethod("GET");
			buildParameters1.setQueryParams(localVarQueryParams1);
			buildParameters1.setCollectionQueryParams(localVarCollectionQueryParams1);
			buildParameters1.setBody(localVarPostBody1);
			buildParameters1.setHeaderParams(localVarHeaderParams1);
			buildParameters1.setFormParams(localVarFormParams1);
			buildParameters1.setAuthNames(localVarAuthNames1);
			buildParameters1.setProgressRequestListener(progressRequestListener);
		
        return apiClient.buildCall(buildParameters1);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call solicitarrcClearcacheValidateBeforeCall(String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        return solicitarrcClearcacheCall(authorization, progressListener, progressRequestListener);

    }

    /**
     * 
     * 
     * @param authorization JWT Token (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Object solicitarrcClearcache(String authorization) throws ApiException {
        ApiResponse<Object> resp = solicitarrcClearcacheWithHttpInfo(authorization);
        return resp.getData();
    }

    /**
     * 
     * 
     * @param authorization JWT Token (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Object> solicitarrcClearcacheWithHttpInfo(String authorization) throws ApiException {
        com.squareup.okhttp.Call call = solicitarrcClearcacheValidateBeforeCall(authorization, null, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Build call for solicitarrcDelete
     * @param id  (required)
     * @param statecode  (optional)
     * @param statuscode  (optional)
     * @param authorization JWT Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call solicitarrcDeleteCall(String id, String statecode, String statuscode, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody21 = null;

        
        String localVarPath21 = APIMETHOD + "{id}"
            .replace("{" + "id" + "}", apiClient.escapeString(id));

        List<Pair> localVarQueryParams21 = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams21 = new ArrayList<>();
        if (statecode != null){
			localVarQueryParams21.addAll(apiClient.parameterToPair("statecode", statecode));
		}
        if (statuscode != null){
			localVarQueryParams21.addAll(apiClient.parameterToPair("statuscode", statuscode));
		}

        Map<String, String> localVarHeaderParams21 = new HashMap<>();
        if (authorization != null){
			localVarHeaderParams21.put(AUTH_TEXT, apiClient.parameterToString(authorization));
		}

        Map<String, Object> localVarFormParams21 = new HashMap<>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams21.put(ACCEPTTEXT, localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams21.put(CONTENTTYPE, localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames21 = new String[] {  };
        BuildParameters buildParameters21=new BuildParameters();
			buildParameters21.setPath(localVarPath21);
			buildParameters21.setMethod("DELETE");
			buildParameters21.setQueryParams(localVarQueryParams21);
			buildParameters21.setCollectionQueryParams(localVarCollectionQueryParams21);
			buildParameters21.setBody(localVarPostBody21);
			buildParameters21.setHeaderParams(localVarHeaderParams21);
			buildParameters21.setFormParams(localVarFormParams21);
			buildParameters21.setAuthNames(localVarAuthNames21);
			buildParameters21.setProgressRequestListener(progressRequestListener);
		
        return apiClient.buildCall(buildParameters21);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call solicitarrcDeleteValidateBeforeCall(String id, String statecode, String statuscode, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling solicitarrcDelete(Async)");
        }
        

        return  solicitarrcDeleteCall(id, statecode, statuscode, authorization, progressListener, progressRequestListener);
        

    }

    /**
     * 
     * 
     * @param id  (required)
     * @param statecode  (optional)
     * @param statuscode  (optional)
     * @param authorization JWT Token (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void solicitarrcDelete(String id, String statecode, String statuscode, String authorization) throws ApiException {
        solicitarrcDeleteWithHttpInfo(id, statecode, statuscode, authorization);
    }

    /**
     * 
     * 
     * @param id  (required)
     * @param statecode  (optional)
     * @param statuscode  (optional)
     * @param authorization JWT Token (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> solicitarrcDeleteWithHttpInfo(String id, String statecode, String statuscode, String authorization) throws ApiException {
        com.squareup.okhttp.Call call = solicitarrcDeleteValidateBeforeCall(id, statecode, statuscode, authorization, null, null);
        return apiClient.execute(call);
    }

 /**
     * Build call for solicitarrcGet
     * @param index  (optional)
     * @param limit  (optional)
     * @param q  (optional)
     * @param orderby  (optional)
     * @param order  (optional)
     * @param fields  (optional)
     * @param filters  (optional)
     * @param fetchcount  (optional)
     * @param authorization JWT Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call solicitarrcGetCall(WebserviceParameters webserviceParameters, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody31 = null;

        
        String localVarPath31 = APIMETHOD + "get";

        List<Pair> localVarQueryParams31 = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams31 = new ArrayList<>();
        if (webserviceParameters.getIndex() != null){
			localVarQueryParams31.addAll(apiClient.parameterToPair("index", webserviceParameters.getIndex()));
		}
        if (webserviceParameters.getLimit() != null){
			localVarQueryParams31.addAll(apiClient.parameterToPair("limit", webserviceParameters.getLimit()));
		}
        if (webserviceParameters.getQ() != null){
			localVarQueryParams31.addAll(apiClient.parameterToPair("q", webserviceParameters.getQ()));
		}
        if (webserviceParameters.getOrderby() != null){
			localVarQueryParams31.addAll(apiClient.parameterToPair("orderby", webserviceParameters.getOrderby()));
		}
        if (webserviceParameters.getOrder() != null){
			localVarQueryParams31.addAll(apiClient.parameterToPair("order", webserviceParameters.getOrder()));
		}
        if (webserviceParameters.getFields() != null){
			localVarQueryParams31.addAll(apiClient.parameterToPair("fields", webserviceParameters.getFields()));
		}
        if (webserviceParameters.getFilters() != null){
			localVarQueryParams31.addAll(apiClient.parameterToPair("filters", webserviceParameters.getFilters()));
		}
        if (webserviceParameters.getFetchcount() != null){
			localVarQueryParams31.addAll(apiClient.parameterToPair("fetchcount", webserviceParameters.getFetchcount()));
		}
        Map<String, String> localVarHeaderParams31 = new HashMap<>();
        if (authorization != null){
			localVarHeaderParams31.put(AUTH_TEXT, apiClient.parameterToString(authorization));
		}

        Map<String, Object> localVarFormParams31 = new HashMap<>();

        final String[] localVarAccepts = {
            APPJSON, TEXTJSON, TEXT_XML
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams31.put(ACCEPTTEXT, localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams31.put(CONTENTTYPE, localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames31 = new String[] {  };
        BuildParameters buildParameters31=new BuildParameters();
			buildParameters31.setPath(localVarPath31);
			buildParameters31.setMethod("GET");
			buildParameters31.setQueryParams(localVarQueryParams31);
			buildParameters31.setCollectionQueryParams(localVarCollectionQueryParams31);
			buildParameters31.setBody(localVarPostBody31);
			buildParameters31.setHeaderParams(localVarHeaderParams31);
			buildParameters31.setFormParams(localVarFormParams31);
			buildParameters31.setAuthNames(localVarAuthNames31);
			buildParameters31.setProgressRequestListener(progressRequestListener);
		
        return apiClient.buildCall(buildParameters31);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call solicitarrcGetValidateBeforeCall(WebserviceParameters webserviceParameters, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        return solicitarrcGetCall(webserviceParameters, authorization, progressListener, progressRequestListener);
        

    }

    /**
     * 
     * 
     * @param index  (optional)
     * @param limit  (optional)
     * @param q  (optional)
     * @param orderby  (optional)
     * @param order  (optional)
     * @param fields  (optional)
     * @param filters  (optional)
     * @param fetchcount  (optional)
     * @param authorization JWT Token (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Object solicitarrcGet(WebserviceParameters webserviceParameters, String authorization) throws ApiException {
        ApiResponse<Object> resp = solicitarrcGetWithHttpInfo(webserviceParameters, authorization);
        return resp.getData();
    }

    /**
     * 
     * 
     * @param index  (optional)
     * @param limit  (optional)
     * @param q  (optional)
     * @param orderby  (optional)
     * @param order  (optional)
     * @param fields  (optional)
     * @param filters  (optional)
     * @param fetchcount  (optional)
     * @param authorization JWT Token (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Object> solicitarrcGetWithHttpInfo(WebserviceParameters webserviceParameters, String authorization) throws ApiException {
        com.squareup.okhttp.Call call = solicitarrcGetValidateBeforeCall(webserviceParameters, authorization, null, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

  /**
     * Build call for solicitarrcGetCodigoPostalLookup
     * @param index  (optional)
     * @param limit  (optional)
     * @param q  (optional)
     * @param orderby  (optional)
     * @param order  (optional)
     * @param fields  (optional)
     * @param filters  (optional)
     * @param fetchcount  (optional)
     * @param authorization JWT Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call solicitarrcGetCodigoPostalLookupCall(WebserviceParameters webserviceParameters, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody41 = null;

        
        String localVarPath41 = APIMETHOD + "getcodigopostallookup";

        List<Pair> localVarQueryParams41 = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams41 = new ArrayList<>();
        if (webserviceParameters.getIndex() != null){
			localVarQueryParams41.addAll(apiClient.parameterToPair("index", webserviceParameters.getIndex()));
		}
        if (webserviceParameters.getLimit() != null){
			localVarQueryParams41.addAll(apiClient.parameterToPair("limit", webserviceParameters.getLimit()));
		}
        if (webserviceParameters.getQ() != null){
			localVarQueryParams41.addAll(apiClient.parameterToPair("q", webserviceParameters.getQ()));
		}
        if (webserviceParameters.getOrderby() != null){
			localVarQueryParams41.addAll(apiClient.parameterToPair("orderby", webserviceParameters.getOrderby()));
		}
        if (webserviceParameters.getOrder() != null){
			localVarQueryParams41.addAll(apiClient.parameterToPair("order", webserviceParameters.getOrder()));
		}
        if (webserviceParameters.getFields() != null){
			localVarQueryParams41.addAll(apiClient.parameterToPair("fields", webserviceParameters.getFields()));
		}
        if (webserviceParameters.getFilters() != null){
			localVarQueryParams41.addAll(apiClient.parameterToPair("filters", webserviceParameters.getFilters()));
		}
        if (webserviceParameters.getFetchcount() != null){
			localVarQueryParams41.addAll(apiClient.parameterToPair("fetchcount", webserviceParameters.getFetchcount()));
		}

        Map<String, String> localVarHeaderParams41 = new HashMap<>();
        if (authorization != null){
			localVarHeaderParams41.put(AUTH_TEXT, apiClient.parameterToString(authorization));
		}

        Map<String, Object> localVarFormParams41 = new HashMap<>();

        final String[] localVarAccepts = {
            APPJSON, TEXTJSON, TEXT_XML
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams41.put(ACCEPTTEXT, localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams41.put(CONTENTTYPE, localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames41 = new String[] {  };
        BuildParameters buildParameters41=new BuildParameters();
			buildParameters41.setPath(localVarPath41);
			buildParameters41.setMethod("GET");
			buildParameters41.setQueryParams(localVarQueryParams41);
			buildParameters41.setCollectionQueryParams(localVarCollectionQueryParams41);
			buildParameters41.setBody(localVarPostBody41);
			buildParameters41.setHeaderParams(localVarHeaderParams41);
			buildParameters41.setFormParams(localVarFormParams41);
			buildParameters41.setAuthNames(localVarAuthNames41);
			buildParameters41.setProgressRequestListener(progressRequestListener);
		
        return apiClient.buildCall(buildParameters41);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call solicitarrcGetCodigoPostalLookupValidateBeforeCall(WebserviceParameters webserviceParameters, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        return solicitarrcGetCodigoPostalLookupCall(webserviceParameters, authorization, progressListener, progressRequestListener);
        

    }

    /**
     * 
     * 
     * @param index  (optional)
     * @param limit  (optional)
     * @param q  (optional)
     * @param orderby  (optional)
     * @param order  (optional)
     * @param fields  (optional)
     * @param filters  (optional)
     * @param fetchcount  (optional)
     * @param authorization JWT Token (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Object solicitarrcGetCodigoPostalLookup(WebserviceParameters webserviceParameters, String authorization) throws ApiException {
        ApiResponse<Object> resp = solicitarrcGetCodigoPostalLookupWithHttpInfo( webserviceParameters, authorization);
        return resp.getData();
    }

    /**
     * 
     * 
     * @param index  (optional)
     * @param limit  (optional)
     * @param q  (optional)
     * @param orderby  (optional)
     * @param order  (optional)
     * @param fields  (optional)
     * @param filters  (optional)
     * @param fetchcount  (optional)
     * @param authorization JWT Token (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Object> solicitarrcGetCodigoPostalLookupWithHttpInfo(WebserviceParameters webserviceParameters, String authorization) throws ApiException {
        com.squareup.okhttp.Call call = solicitarrcGetCodigoPostalLookupValidateBeforeCall(webserviceParameters, authorization, null, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

   /**
     * Build call for solicitarrcGet_0
     * @param id  (required)
     * @param authorization JWT Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call solicitarrcGet0Call(String id, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody51 = null;

        
        String localVarPath51 = APIMETHOD + "{id}"
            .replace("{" + "id" + "}", apiClient.escapeString(id));

        List<Pair> localVarQueryParams51 = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams51 = new ArrayList<>();

        Map<String, String> localVarHeaderParams51 = new HashMap<>();
        if (authorization != null){
			localVarHeaderParams51.put(AUTH_TEXT, apiClient.parameterToString(authorization));
		}

        Map<String, Object> localVarFormParams51 = new HashMap<>();

        final String[] localVarAccepts = {
            APPJSON, TEXTJSON, TEXT_XML
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams51.put(ACCEPTTEXT, localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams51.put(CONTENTTYPE, localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames51 = new String[] {  };
        BuildParameters buildParameters51=new BuildParameters();
			buildParameters51.setPath(localVarPath51);
			buildParameters51.setMethod("GET");
			buildParameters51.setQueryParams(localVarQueryParams51);
			buildParameters51.setCollectionQueryParams(localVarCollectionQueryParams51);
			buildParameters51.setBody(localVarPostBody51);
			buildParameters51.setHeaderParams(localVarHeaderParams51);
			buildParameters51.setFormParams(localVarFormParams51);
			buildParameters51.setAuthNames(localVarAuthNames51);
			buildParameters51.setProgressRequestListener(progressRequestListener);
		
        return apiClient.buildCall(buildParameters51);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call solicitarrcGet0ValidateBeforeCall(String id, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling solicitarrcGet_0(Async)");
        }
        return  solicitarrcGet0Call(id, authorization, progressListener, progressRequestListener);
        

    }

    /**
     * 
     * 
     * @param id  (required)
     * @param authorization JWT Token (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Object solicitarrcGet0(String id, String authorization) throws ApiException {
        ApiResponse<Object> resp = solicitarrcGet0WithHttpInfo(id, authorization);
        return resp.getData();
    }

    /**
     * 
     * 
     * @param id  (required)
     * @param authorization JWT Token (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Object> solicitarrcGet0WithHttpInfo(String id, String authorization) throws ApiException {
        com.squareup.okhttp.Call call = solicitarrcGet0ValidateBeforeCall(id, authorization, null, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

 /**
     * Build call for solicitarrcPost
     * @param value  (required)
     * @param authorization JWT Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call solicitarrcPostCall(CSolicitarRCAttributes value, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody61 = value;

        
        String localVarPath61 = APIMETHODSLASH;

        List<Pair> localVarQueryParams61 = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams61 = new ArrayList<>();

        Map<String, String> localVarHeaderParams61 = new HashMap<>();
        if (authorization != null){
			localVarHeaderParams61.put(AUTH_TEXT, apiClient.parameterToString(authorization));
		}

        Map<String, Object> localVarFormParams61 = new HashMap<>();

        final String[] localVarAccepts = {
            APPJSON, TEXTJSON, TEXT_XML
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams61.put(ACCEPTTEXT, localVarAccept);

        final String[] localVarContentTypes = {
            APPJSON, TEXTJSON, TEXT_XML, URLENCODE
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams61.put(CONTENTTYPE, localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames61 = new String[] {  };
        BuildParameters buildParameters61=new BuildParameters();
			buildParameters61.setPath(localVarPath61);
			buildParameters61.setMethod("POST");
			buildParameters61.setQueryParams(localVarQueryParams61);
			buildParameters61.setCollectionQueryParams(localVarCollectionQueryParams61);
			buildParameters61.setBody(localVarPostBody61);
			buildParameters61.setHeaderParams(localVarHeaderParams61);
			buildParameters61.setFormParams(localVarFormParams61);
			buildParameters61.setAuthNames(localVarAuthNames61);
			buildParameters61.setProgressRequestListener(progressRequestListener);
		
        return apiClient.buildCall(buildParameters61);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call solicitarrcPostValidateBeforeCall(CSolicitarRCAttributes value, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        if (value == null) {
            throw new ApiException("Missing the required parameter 'value' when calling solicitarrcPost(Async)");
        }
        

        return solicitarrcPostCall(value, authorization, progressListener, progressRequestListener);
        

    }

    /**
     * 
     * 
     * @param value  (required)
     * @param authorization JWT Token (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Object solicitarrcPost(CSolicitarRCAttributes value, String authorization) throws ApiException {
        ApiResponse<Object> resp = solicitarrcPostWithHttpInfo(value, authorization);
        return resp.getData();
    }

    /**
     * 
     * 
     * @param value  (required)
     * @param authorization JWT Token (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Object> solicitarrcPostWithHttpInfo(CSolicitarRCAttributes value, String authorization) throws ApiException {
        com.squareup.okhttp.Call call = solicitarrcPostValidateBeforeCall(value, authorization, null, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

  /**
     * Build call for solicitarrcPut
     * @param id  (required)
     * @param value  (required)
     * @param authorization JWT Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call solicitarrcPutCall(String id, CSolicitarRCAttributes value, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody71 = value;

        
        String localVarPath71 = APIMETHOD + "{id}"
            .replace("{" + "id" + "}", apiClient.escapeString(id));

        List<Pair> localVarQueryParams71 = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams71 = new ArrayList<>();

        Map<String, String> localVarHeaderParams71 = new HashMap<>();
        if (authorization != null){
			localVarHeaderParams71.put(AUTH_TEXT, apiClient.parameterToString(authorization));
		}

        Map<String, Object> localVarFormParams71 = new HashMap<>();

        final String[] localVarAccepts = {
            APPJSON, TEXTJSON, TEXT_XML
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams71.put(ACCEPTTEXT, localVarAccept);

        final String[] localVarContentTypes = {
            APPJSON, TEXTJSON, TEXT_XML, URLENCODE
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams71.put(CONTENTTYPE, localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames71 = new String[] {  };
        BuildParameters buildParameters71=new BuildParameters();
			buildParameters71.setPath(localVarPath71);
			buildParameters71.setMethod("PUT");
			buildParameters71.setQueryParams(localVarQueryParams71);
			buildParameters71.setCollectionQueryParams(localVarCollectionQueryParams71);
			buildParameters71.setBody(localVarPostBody71);
			buildParameters71.setHeaderParams(localVarHeaderParams71);
			buildParameters71.setFormParams(localVarFormParams71);
			buildParameters71.setAuthNames(localVarAuthNames71);
			buildParameters71.setProgressRequestListener(progressRequestListener);
		
        return apiClient.buildCall(buildParameters71);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call solicitarrcPutValidateBeforeCall(String id, CSolicitarRCAttributes value, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling solicitarrcPut(Async)");
        }
        
        
        if (value == null) {
            throw new ApiException("Missing the required parameter 'value' when calling solicitarrcPut(Async)");
        }
        

        return solicitarrcPutCall(id, value, authorization, progressListener, progressRequestListener);
        

    }

    /**
     * 
     * 
     * @param id  (required)
     * @param value  (required)
     * @param authorization JWT Token (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Object solicitarrcPut(String id, CSolicitarRCAttributes value, String authorization) throws ApiException {
        ApiResponse<Object> resp = solicitarrcPutWithHttpInfo(id, value, authorization);
        return resp.getData();
    }

    /**
     * 
     * 
     * @param id  (required)
     * @param value  (required)
     * @param authorization JWT Token (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Object> solicitarrcPutWithHttpInfo(String id, CSolicitarRCAttributes value, String authorization) throws ApiException {
        com.squareup.okhttp.Call call = solicitarrcPutValidateBeforeCall(id, value, authorization, null, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

}
